<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (170)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
  </head>
  <body>
    <h1 id="lookahead-and-lookbehind">Lookahead and lookbehind</h1>
    <p>
      Sometimes we need to find only those matches for a pattern that are
      followed or preceded by another pattern.
    </p>
    <p>
      There’s a special syntax for that, called “lookahead” and “lookbehind”,
      together referred to as “lookaround”.
    </p>
    <p>
      For the start, let’s find the price from the string like
      <code>subject:1 turkey costs 30€</code>. That is: a number, followed by
      <code>subject:€</code> sign.
    </p>
    <h2 id="lookahead">Lookahead</h2>
    <p>
      The syntax is: <code>pattern:X(?=Y)</code>, it means “look for
      <code>pattern:X</code>, but match only if followed by
      <code>pattern:Y</code>”. There may be any pattern instead of
      <code>pattern:X</code> and <code>pattern:Y</code>.
    </p>
    <p>
      For an integer number followed by <code>subject:€</code>, the regexp will
      be <code>pattern:\d+(?=€)</code>:
    </p>
    <p>```js run let str = “1 turkey costs 30€”;</p>
    <p>
      alert(str.match(/(?=€)/)); // 30, the number 1 is ignored, as it’s not
      followed by € ```
    </p>
    <p>
      Please note: the lookahead is merely a test, the contents of the
      parentheses <code>pattern:(?=...)</code> is not included in the result
      <code>match:30</code>.
    </p>
    <p>
      When we look for <code>pattern:X(?=Y)</code>, the regular expression
      engine finds <code>pattern:X</code> and then checks if there’s
      <code>pattern:Y</code> immediately after it. If it’s not so, then the
      potential match is skipped, and the search continues.
    </p>
    <p>
      More complex tests are possible, e.g. <code>pattern:X(?=Y)(?=Z)</code>
      means:
    </p>
    <ol type="1">
      <li>Find <code>pattern:X</code>.</li>
      <li>
        Check if <code>pattern:Y</code> is immediately after
        <code>pattern:X</code> (skip if isn’t).
      </li>
      <li>
        Check if <code>pattern:Z</code> is also immediately after
        <code>pattern:X</code> (skip if isn’t).
      </li>
      <li>
        If both tests passed, then the <code>pattern:X</code> is a match,
        otherwise continue searching.
      </li>
    </ol>
    <p>
      In other words, such pattern means that we’re looking for
      <code>pattern:X</code> followed by <code>pattern:Y</code> and
      <code>pattern:Z</code> at the same time.
    </p>
    <p>
      That’s only possible if patterns <code>pattern:Y</code> and
      <code>pattern:Z</code> aren’t mutually exclusive.
    </p>
    <p>
      For example, <code>pattern:\d+(?=\s)(?=.*30)</code> looks for
      <code>pattern:\d+</code> that is followed by a space
      <code>pattern:(?=\s)</code>, and there’s <code>30</code> somewhere after
      it <code>pattern:(?=.*30)</code>:
    </p>
    <p>```js run let str = “1 turkey costs 30€”;</p>
    <p>alert(str.match(/(?=)(?=.*30)/)); // 1 ```</p>
    <p>In our string that exactly matches the number <code>1</code>.</p>
    <h2 id="negative-lookahead">Negative lookahead</h2>
    <p>
      Let’s say that we want a quantity instead, not a price from the same
      string. That’s a number <code>pattern:\d+</code>, NOT followed by
      <code>subject:€</code>.
    </p>
    <p>For that, a negative lookahead can be applied.</p>
    <p>
      The syntax is: <code>pattern:X(?!Y)</code>, it means “search
      <code>pattern:X</code>, but only if not followed by
      <code>pattern:Y</code>”.
    </p>
    <p>```js run let str = “2 turkeys cost 60€”;</p>
    <p>alert(str.match(/?!€)/g)); // 2 (the price is not matched) ```</p>
    <h2 id="lookbehind">Lookbehind</h2>
    <p>Lookahead allows to add a condition for “what follows”.</p>
    <p>
      Lookbehind is similar, but it looks behind. That is, it allows to match a
      pattern only if there’s something before it.
    </p>
    <p>The syntax is:</p>
    <ul>
      <li>
        Positive lookbehind: <code>pattern:(?&lt;=Y)X</code>, matches
        <code>pattern:X</code>, but only if there’s
        <code>pattern:Y</code> before it.
      </li>
      <li>
        Negative lookbehind: <code>pattern:(?&lt;!Y)X</code>, matches
        <code>pattern:X</code>, but only if there’s no
        <code>pattern:Y</code> before it.
      </li>
    </ul>
    <p>
      For example, let’s change the price to US dollars. The dollar sign is
      usually before the number, so to look for <code>$30</code> we’ll use
      <code>pattern:(?&lt;=\$)\d+</code> – an amount preceded by
      <code>subject:$</code>:
    </p>
    <p>```js run let str = “1 turkey costs $30”;</p>
    <p>
      // the dollar sign is escaped $ alert(str.match(/(?&lt;=$)/)); // 30
      (skipped the sole number) ```
    </p>
    <p>
      And, if we need the quantity – a number, not preceded by
      <code>subject:$</code>, then we can use a negative lookbehind
      <code>pattern:(?&lt;!\$)\d+</code>:
    </p>
    <p>```js run let str = “2 turkeys cost $60”;</p>
    <p>alert(str.match(/(?&lt;!$)/g)); // 2 (the price is not matched) ```</p>
    <h2 id="capturing-groups">Capturing groups</h2>
    <p>
      Generally, the contents inside lookaround parentheses does not become a
      part of the result.
    </p>
    <p>
      E.g. in the pattern <code>pattern:\d+(?=€)</code>, the
      <code>pattern:€</code> sign doesn’t get captured as a part of the match.
      That’s natural: we look for a number <code>pattern:\d+</code>, while
      <code>pattern:(?=€)</code> is just a test that it should be followed by
      <code>subject:€</code>.
    </p>
    <p>
      But in some situations we might want to capture the lookaround expression
      as well, or a part of it. That’s possible. Just wrap that part into
      additional parentheses.
    </p>
    <p>
      In the example below the currency sign <code>pattern:(€|kr)</code> is
      captured, along with the amount:
    </p>
    <p>
      ```js run let str = “1 turkey costs 30€”; let regexp = /(?=(€|kr))/; //
      extra parentheses around €|kr
    </p>
    <p>alert(str.match(regexp)); // 30, € ```</p>
    <p>And here’s the same for lookbehind:</p>
    <p>
      ```js run let str = “1 turkey costs $30”; let regexp = /(?&lt;=($|£))/;
    </p>
    <p>alert(str.match(regexp)); // 30, $ ```</p>
    <h2 id="summary">Summary</h2>
    <p>
      Lookahead and lookbehind (commonly referred to as “lookaround”) are useful
      when we’d like to match something depending on the context before/after
      it.
    </p>
    <p>
      For simple regexps we can do the similar thing manually. That is: match
      everything, in any context, and then filter by context in the loop.
    </p>
    <p>
      Remember, <code>str.match</code> (without flag <code>pattern:g</code>) and
      <code>str.matchAll</code> (always) return matches as arrays with
      <code>index</code> property, so we know where exactly in the text it is,
      and can check the context.
    </p>
    <p>But generally lookaround is more convenient.</p>
    <p>Lookaround types:</p>
    <table>
      <thead>
        <tr class="header">
          <th>Pattern</th>
          <th>type</th>
          <th>matches</th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td><code>X(?=Y)</code></td>
          <td>Positive lookahead</td>
          <td><code>pattern:X</code> if followed by <code>pattern:Y</code></td>
        </tr>
        <tr class="even">
          <td><code>X(?!Y)</code></td>
          <td>Negative lookahead</td>
          <td>
            <code>pattern:X</code> if not followed by <code>pattern:Y</code>
          </td>
        </tr>
        <tr class="odd">
          <td><code>(?&lt;=Y)X</code></td>
          <td>Positive lookbehind</td>
          <td><code>pattern:X</code> if after <code>pattern:Y</code></td>
        </tr>
        <tr class="even">
          <td><code>(?&lt;!Y)X</code></td>
          <td>Negative lookbehind</td>
          <td><code>pattern:X</code> if not after <code>pattern:Y</code></td>
        </tr>
      </tbody>
    </table>
  </body>
</html>
